{$I-}
{Uses DOS;}
{$IFDEF OS2}
Const OS='OS2';
Type  Integer=LongInt;
{$ELSE}
Const OS='DOS';
{$ENDIF}
Type DirP=^Dir;
     Dir=Record
          Path:String[79];
          Next:DirP;
         End;
     FNP=^FN;
     FN=Record
         Name:String[12];
         Count:Word;
         Next:FNP;
        End;
Var F,F2:Text;
    TopDir,CurDir,PrevDir:DirP;
    TopFN,CurFN,PrevFN,TmpFN:FNP;
    PrevTime:String[8];
    S:String;S1:String[12];
    S2:String;
    FCount,DCount,SCount,PCount:Word;
    DLCForMat:String[10];
   
Function SearchFN(S:String):FNP;
Var CurFN:FNP;
Begin
 CurFN:=TopFN;
 While CurFN<>Nil do If CurFN^.Name=S then Break else CurFN:=CurFN^.Next;
 SearchFN:=CurFN
End;

Function ValidFile(S:String):Boolean;
Var S1:String[3];
Begin
S1:=Copy(S,Pos('.',S)+1,3);
ValidFile:=False;
If (S1<>'TIC')and(S1<>'REQ') then Begin
 If Length(S1)=3 then Dec(Byte(S1[0]));
 If (S1<>'MO')and(S1<>'TH')and(S1<>'TU')and(S1<>'FR')and(S1<>'SA')and(S1<>'SU')and(S1<>'WE')and(S1<>'PK') then ValidFile:=True;
End;
End;

Procedure UpdateDLC(Var S:String;N:Word;D:String);
Var S1:String;
    I,J:Byte;
    W:Word;
    Code:Integer;
Begin
I:=Pos(D[1],S);
If I=0 then Exit;
If S[I+Length(D)-1]<>D[Length(D)] then Exit;
S1:=Copy(S,I+1,Length(D)-2);
Val(S1,W,Code);
Inc(W,N);
Str(W:10,S1);
Delete(S1,1,12-Length(D));
For J:=1 to Length(D)-2 do Begin
 If S1[J]=' ' then S[I+J]:=D[J+1] else S[I+J]:=S1[J]
End;
End;

Begin
Writeln('T-DLCA 0.1/',OS,'  T-Mail Download Counter            (C) Alex Matveev (2:5020/968)');
If ParamCount<2 then Begin
 Writeln('T-DLCA <Log> <DirList> <DLCFormat>');
 Halt(1);
End;
If ParamStr(3)<>'' then DLCFormat:=ParamStr(3) else DLCFormat:='[000]';
Assign(F,ParamStr(2));
Reset(F);
if IOResult<>0 then Begin
 Writeln(' Directory list not found');
 Halt(2);
End;
Writeln('Reading directory list ...');
PrevDir:=Nil;
While Not EOF(F) do Begin
 New(CurDir);
 If PrevDir=Nil then TopDir:=CurDir else PrevDir^.Next:=CurDir;
 Readln(F,CurDir^.Path);
 If CurDir^.Path[Length(CurDir^.Path)]<>'\' then CurDir^.Path:=CurDir^.Path+'\';
 PrevDir:=CurDir;
End;
CurDir^.Next:=Nil;
Close(F);

Assign(F,ParamStr(1));
Reset(F);
If IOResult<>0 then Begin
 Writeln(' Log File not found');
 Halt(3);
End;
Writeln('Scanning log ...');
PrevFN:=Nil;
TopFN:=Nil;
FCount:=0;
While Not EOF(F) do Begin
 Readln(F,S);
 If S='' then Continue;
 If Copy(S,1,8)<>PrevTime then Begin
  PrevTime:=S;Write(#13,PrevTime,':00 Files: ',FCount);
 End;
 S2:=S;
 If (Copy(S,16,5)='ZS-16')or(Copy(S,16,5)='JS-16') then Begin
  Delete(S,1,15);
  Delete(S,1,Pos(' ',S));
  S1:=Copy(S,1,Pos(' ',S)-1);Delete(S,1,Pos(' ',S));
  If ValidFile(S1) then Begin
   Delete(S,1,Pos(' ',S));
   If Copy(S,1,Pos(' ',S)-1)='(from' then Begin Delete(S,1,Pos(' ',S));Delete(S,1,Pos(' ',S)); End;
   If Copy(S,1,Pos(' ',S)-1)='OK:' then Begin
    TmpFN:=SearchFN(S1);
    If TmpFN=Nil then Begin
     New(CurFN);
     If CurFN=Nil then Begin
      Writeln(#13,' Can''t handle more than ',FCount,' files');
      Halt(4);
     End;
     If PrevFN=Nil then TopFN:=CurFN else PrevFN^.Next:=CurFN;
     CurFN^.Name:=S1;CurFN^.Count:=1;
     Inc(FCount);
     PrevFN:=CurFN;
     CurFN^.Next:=Nil;
    End else Inc(TmpFN^.Count);
   End;
  End;
 End;
End;
If S2<>'' then Writeln(#13,Copy(S2,1,11),' Files: ',FCount);
Close(F);
If Fcount=0 then Begin
 Writeln(' Nothing to update');
End;
PCount:=0;
DCount:=0;
Writeln('Updating Download Counters ...');
CurDir:=TopDir;
While CurDir<>Nil Do Begin
 Write('Processing ',CurDir^.Path,'FILES.BBS ... ');
 Assign(F,CurDir^.Path+'FILES.BBS');
 Reset(F);
 If IOREsult<>0 then Writeln('not found.') else Begin
  Assign(F2,CurDir^.Path+'FILES.$$$');
  Rewrite(F2);
  SCount:=0;
  While Not EOF(F) do Begin
   Readln(F,S);
   S1:=Copy(S,1,Pos(' ',S)-1);
   If (Length(S1)>=1)and(Length(S1)<=12) then Begin
    TmpFN:=SearchFN(S1);
    If TmpFN<>Nil then Begin
     If ParamStr(4)='-D' then Writeln(#13,' ',S);
     UpdateDLC(S,TmpFN^.Count,DLCForMat);
     If ParamStr(4)='-D' then Writeln(#13,' ',S);
     Inc(SCount);Inc(PCount);
    End;
   End;
   Writeln(F2,S);
  End;
  Close(F);
  Close(F2);
  If ParamStr(4)='-D' then SCount:=0;
  If SCount<>0 then Begin
   Erase(F);
   Rename(F2,CurDir^.Path+'FILES.BBS');
   If IOResult<>0 then Write(' can''t rename FILES.$$$ to FILES.BBS ');
  End else Erase(F2);
  Writeln(SCount,' files updated.');
 End;
 CurDir:=CurDir^.Next;
 Inc(DCount);
End;
Writeln;
Writeln('Statistics:');
Writeln(' Found     ',FCount,' downloaded files');
Writeln(' Processed ',Dcount,' fileareas');
Writeln(' Updated   ',PCount,' file ocurences');
End.
